# (C) 2009 M-Logic, Inc. All Rights Reserved.
#
# $Id$

package TwitterWidget::Plugin;

use strict;
use warnings;

my $DEFAULT_TITLE  = 'Twitter updates from M-Logic';
my $DEFAULT_USER   = 'mlogic';
my $DEFAULT_TWEETS = 5;

sub plugin {
    return MT->component('TwitterWidget');
}

sub _hdlr_widget {
    my $app = shift;
    my ( $tmpl, $param ) = @_;
    my $plugin = plugin();

    my $blog_id = $param->{blog_id};
    my $blog_config;
    $blog_config = $plugin->get_config_hash('blog:'.$blog_id) if ($blog_id);
    my $config = $plugin->get_config_hash('system');
    my $user;
    my $tweets;
    if ($blog_config) {
        $user = $blog_config->{twitterwidget_user} ? 
                $blog_config->{twitterwidget_user} : 
                ($config->{twitterwidget_user} ? $config->{twitterwidget_user} : $DEFAULT_USER);
        $tweets = $blog_config->{twitterwidget_tweets} ? 
                  $blog_config->{twitterwidget_tweets} : 
                  ($config->{twitterwidget_tweets} ? $config->{twitterwidget_tweets} : $DEFAULT_TWEETS);
    } else {
        $user   = $config->{twitterwidget_user} ? $config->{twitterwidget_user} : $DEFAULT_USER;
        $tweets = $config->{twitterwidget_tweets} ? $config->{twitterwidget_tweets} : $DEFAULT_TWEETS;
    }
    $param->{twitterwidget_user} = $user;
    $param->{twitterwidget_tweets} = $tweets;
    $param->{twitterwidget_follow} = $app->translate('follow [_1] on Twitter', $user);
}

sub _xfrm_widget_param {
    my ($cb, $app, $param, $tmpl) = @_;

    my $node = $tmpl->getElementsByTagName('app:widget')->[0];
    if (defined $node) {
        my $plugin = plugin();
        my $blog_id = $param->{blog_id};
        my $blog_config;
        $blog_config = $plugin->get_config_hash('blog:'.$blog_id) if ($blog_id);
        my $config = $plugin->get_config_hash('system');
        my $title = $blog_config && $blog_config->{twitterwidget_title} ? 
                    $blog_config->{twitterwidget_title} :
                    ($config->{twitterwidget_title} ? $config->{twitterwidget_title} : $DEFAULT_TITLE);
        $node->setAttribute('label', $title);
    }
}

1;
